#include <Wire.h>
#include "ComMotion.h"
#include "Multiservo.h"
#include "ModbusRTU.h"
#include "config.h"
#include "maindat.h"


//MS  multiservo;
Multiservo servo[SERVO_COUNT];

/*
*********************
* рабочие данные * 
*********************
*/
//контрольный регистр
int16_t	CntrlReg;
//время цикла
uint16_t timeCycleMax;
//массив данных для сервомашин
int16_t	dservo[SERVO_COUNT]  ;
//массив данных для моторов
int16_t	dmotor[MOTOR_COUNT]  ;

//номер исполнения по I2C для последовательности - цель минимизировать простой по Serial
int  dnum;

// Переменная хранящее максимальное значение uint32_t(unsigned long).
#define unsignedLongMax 4294967295UL

// Переменная хранящее 1.
#define digitalOne 1UL

uint32_t GetDifferenceULong(uint32_t BeginTime, uint32_t EndTime)
{
  	if (EndTime < BeginTime)
  	{
    		// Защита от переполнения
    		return unsignedLongMax - BeginTime + EndTime + digitalOne;
  	}
  	else
    		return EndTime - BeginTime;
	return 0;
}
uint32_t	pwait;

//
void  setup()
{
	Wire.begin ();  // Required to support I2C communication
  	sMRTU_INIT();
  	//Serial.setTimeout(_sMRTU_Timeout_4);
  	Serial.begin(_sMRTU_Baudrate);
	Serial.setTimeout(_sMRTU_Timeout_4);
  	//ComMotion
#if(_BC_Configurration > 0) //конфигурация ComMotion
  	BasicConfig(_BC_i2c_mode,
  	_BC_config,
  	_BC_lovbat,
  	_BC_M1_Imax,
  	_BC_M2_Imax,
  	_BC_M3_Imax,
  	_BC_M4_Imax,
  	_BC_i2c_nooffset,
  	1);
	delay(20);
#endif
  	//init ComMotiom shield of 4 motor drivers
  	IndividualMotorControl(_CM_M1_def, _CM_M2_def, _CM_M3_def, _CM_M4_def);
  	for(int i = 0; i<MOTOR_COUNT; ++i)
    		dmotor[i]  = 0;
  		//init Multiservo
  	for (int i = 0; i < SERVO_COUNT; ++i)
  	{
    		servo[i].attach(i);
    		servo[i].write(0);
    		//multiservo.pos[i]  = 0;
    		dservo[i]  = 0;
    		delay(20);
  	}
	CntrlReg	= 0;
  	dnum 		= 0;
	timeCycleMax	= 0;
	pwait		= micros();
}

//
void loop()
{
	uint16_t timeCycleBegin = micros();
 	//штатная работа
#if(_SERVO_ALL == 1)
    	switch(dnum)
  	{
    		//Multiservo
    		case 0:
      			servo[0].write(dservo[0]);
      			dnum++;
      			break;
     		case 1:
      			servo[1].write(dservo[1]);
      			dnum++;
      			break;
    		case 2:
      			servo[2].write(dservo[2]);
      			dnum++;
      			break;
    		case 3:
      			servo[3].write(dservo[3]);
      			dnum++;
      			break;
    		case 4:
      			servo[4].write(dservo[4]);
      			dnum++;
      			break;
    		case 5:
      			servo[5].write(dservo[5]);
      			dnum++;
      			break;
    		case 6:
      			servo[6].write(dservo[6]);
      			dnum++;
      			break;
    		case 7:
      			servo[7].write(dservo[7]);
      			dnum++;
      			break;
    		case 8:
      			servo[8].write(dservo[8]);
      			dnum++;
      			break;
    		case 9:
      			servo[9].write(dservo[9]);
      			dnum++;
      			break;
    		case 10:
      			servo[10].write(dservo[10]);
      			dnum++;
      			break;
    		case 11:
      			servo[11].write(dservo[11]);
      			dnum++;
      			break;
    		case 12:
      			servo[12].write(dservo[12]);
      			dnum++;
      			break;
    		case 13:
      			servo[13].write(dservo[13]);
      			dnum++;
      			break;
    		case 14:
      			servo[14].write(dservo[14]);
      			dnum++;
      			break;
    		case 15:
      			servo[15].write(dservo[15]);
      			dnum++;
      			break;
    		case 16:
      			servo[16].write(dservo[16]);
      			dnum++;
      			break;
    		case 17:
      			servo[17].write(dservo[17]);
      			dnum++;
      			break;
    		//ComMotion driver for 4 motors - значения моторов
    		case 18:
      			IndividualMotorControl(dmotor[0], dmotor[1], dmotor[2], dmotor[3]);
			delay(15); //оставил для MCU1 и MCU2
      			dnum = 0;
      			break;
    		default:
      			dnum = 0;
      			break;
  	}
#else
	switch(dnum)
  	{
		//Multiservo
    		case 0:
			if(GetDifferenceULong(pwait, micros()) > _i2c_wait)
			{
				pwait = GetDifferenceULong(pwait, micros());
      				servo[0].write(dservo[0]);
      				dnum = 1;//dnum++;
			}
      			break;
     		case 1:
			if(GetDifferenceULong(pwait, micros()) > _i2c_wait)
			{
				pwait = GetDifferenceULong(pwait, micros());
      				servo[1].write(dservo[1]);
      				dnum = 2;//dnum++;
			}
      			break;
    		//ComMotion driver for 4 motors - значения моторов
    		case 2:
			if(GetDifferenceULong(pwait, micros()) > _i2c_wait)
			{
				pwait = GetDifferenceULong(pwait, micros());
				mIndividualMotorControl((uint8_t*)&dmotor[0], (uint8_t*)&dmotor[1], (uint8_t*)&dmotor[2], (uint8_t*)&dmotor[3]);
      				dnum = 0;
			}
      			break;
    		default:
      			dnum = 0;
      			break;
  	}
	uint16_t timeCycle = (uint16_t)GetDifferenceULong((uint32_t)timeCycleBegin, (uint32_t)micros());
	if (timeCycle > timeCycleMax)
        	timeCycleMax = timeCycle;
#endif
}

//
void serialEvent()
{
 	MRTU_rWORK();
}






